Graphics3D 800,600,32,2
SetBuffer BackBuffer()

pxCreateWorld(1,"http://forum.boolean.name/")

cam = CreateCamera()
PositionEntity cam,0,100,-200
CameraClsColor cam,128,128,128
CreateLight()

plane = CreatePlane()
EntityColor plane, 0,128,128

Spetsnaz = LoadAnimMesh("Spetsnaz.b3d")
Walk = LoadAnimSeq(Spetsnaz, "Walk.b3d")
SpetsnazPX = LoadAnimMesh("SpetsnazPX.b3d")

HideEntity Spetsnaz
HideEntity SpetsnazPX

Global Kalash = LoadSound("ak47-1.wav")

Repeat 
	If KeyHit(57) Then CreateMan(Spetsnaz, SpetsnazPX,Rand(-100,100),50,Rand(0,100))
	If KeyHit(42) Then RagDollAllMen()
	
	If MouseHit(1) Then Shoot(cam, MouseX(), MouseY())
	pxRenderPhysic(10,0)
	UpdateRagdolls()
	UpdateWorld()
	RenderWorld()
	Flip
Until KeyHit(1)
End

Type Ragdoll
	Field Mesh ; 
	Field Joints[100] ;  
	Field Bodies[100] ;  
	Field Bones[100] ;  
End Type

Function CreateRagdoll(man, px)
	Animate man,0,0,1
	R.Ragdoll = New Ragdoll
	If EntityClass (man) <> "Mesh" Then	
		R\Mesh = GetChild(man,1)
		EntityParent R\Mesh,0
		FreeEntity man
	Else
		R\Mesh = Man
	End If
	CreateHullsForAllChilds(R\Mesh, px, R)
	DeparentAllChilds(R\Mesh)
End Function

Function DeparentAllChilds(mesh)
	Repeat
		If CountChildren(mesh) = 0 Then Exit
		DeparentAllChilds(GetChild(mesh,1))	
	Forever 
	EntityParent mesh,0	
End Function

Function UpdateRagdolls()
	For R.Ragdoll = Each Ragdoll
		For i= 0 To 100
			If R\Bodies[i] = 0 Then Exit
			pxBodySetEntity R\Bones[i], R\Bodies[i]
		Next
	Next
End Function

Function CreateHullsForAllChilds(mesh, pxmesh, R.Ragdoll, batya=0)
	HullMesh = FindChild(pxmesh, EntityName(mesh)+"px")
	If HullMesh Then
		Hull = BodyCreateHull(HullMesh, 10)
		pxBodySetPosition Hull, EntityX(Mesh,1), EntityY(Mesh,1), EntityZ(Mesh,1)
		pxBodySetRotation Hull, EntityPitch(Mesh,1), EntityYaw(Mesh,1), EntityRoll(Mesh,1)
		
		For i=0 To 100
			If R\Bodies[i] = 0 Then 
				R\Bodies[i] = Hull
				R\Bones[i] = Mesh
				Exit
			End If
		Next		
		If Batya Then
			Joint = pxJointCreateSpherical (batya,Hull,pxBodyGetPositionX(Hull),pxBodyGetPositionY(Hull),pxBodyGetPositionZ(Hull),0,1,0)
			pxJointSphericalSetLimitAngle(Joint, 30,1, 0)
			pxJointSphericalSetLimitTwist(Joint,-10,10,10,1,0)
			pxJointSphericalSetLimitSpring(Joint, 10, 1, 0)
			For i=0 To 100
			If R\Joints[i] = 0 Then 
				R\Joints[i] = Joint
				Exit
			End If
		Next	
		End If
	End If
	For i=1 To CountChildren(mesh)
		CreateHullsForAllChilds(GetChild(mesh,i), pxmesh, R, Hull)
	Next
End Function

Function BodyCreateHull%(mesh%, mass#)

    Local nsurf = CountSurfaces(mesh)
    Local nvert = 0
    For ns = 1 To nsurf
        Local surf = GetSurface(mesh,ns)
        nvert = nvert + CountVertices(surf)
    Next
         vbank = CreateBank(nvert*4*3)
    nv = 0
    For ns = 1 To nsurf
        surf = GetSurface(mesh,ns)
        nvv = CountVertices(surf)
        For nvc = 0 To nvv - 1
             PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
             PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
             PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
            nv = nv+1
        Next
    Next
    Local bbb%= pxBodyCreateHull(vbank, nvert, mass)
    FreeBank vbank
    Return bbb
End Function

Type Man
	Field Mesh
	Field pxMesh
	Field PickPivot
End Type

Function CreateMan(Mesh, pxMesh, x#,y#,z#)
	M.Man = New Man
	M\Mesh = CopyEntity(Mesh)
	PositionEntity M\Mesh,x,y,z
	Animate M\Mesh,1,.5,1
	M\PXMesh = PXMesh
	
	M\PickPivot = CreatePivot()

	PositionEntity M\PickPivot,x,y+35,z
	EntityPickMode M\PickPivot, 1
	EntityRadius M\PickPivot,15,40
End Function

Function RagDollAllMen()
	For M.Man = Each Man
		CreateRagdoll(M\Mesh, M\pxMesh)
		FreeEntity M\PickPivot
		Delete M
	Next
End Function

Function Shoot(cam, x,y)
	PlaySound Kalash
	CameraPick cam, x,y	
	If PickedEntity() Then
		For M.Man = Each Man
			If M\PickPivot = PickedEntity() Then
				CreateRagdoll(M\Mesh, M\pxMesh)
				FreeEntity M\PickPivot
				Delete M
				Exit
			End If
		Next
	End If
End Function 